/*********************************************************************
  sym.c - simple .sym file dump
  $Id: sym.c,v 1.4 2007/07/28 23:47:51 Steven Exp $

 29 Jul 04 SHL Show address as seg:address
 01 Jul 05 SHL Correct SymOffset def
 01 Jul 05 SHL Debug code for large file debug (DBGLRG)

*/


#define INCL_BASE
#define INCL_DOS
#include <os2.h>

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>

#include "sym.h"

#define DBGLRG 1

int main(int argc,char *argv[])
{
   FILE * SymFile;
   MAPDEF MapDef;
   SEGDEF SegDef;
   SEGDEF *pSegDef;
   SYMDEF32 SymDef32;
   SYMDEF16 SymDef16;
   CHAR	Buffer[258];		// fixme to not overflow
   UINT SegNum;
   UINT SymNum;
   ULONG SegOffset;
   ULONG SymPtrOffset;
   USHORT SymOffset;

   if (argc==1) {
      printf("No file name entered\n");
      exit(1);
   } else {
      SymFile=fopen(argv[1],"rb");
      if (SymFile==0) {
	 perror("Error opening file ");
	 exit(99);
      } /* endif */
   } /* endif */

   fread(&MapDef,sizeof(MAPDEF),1,SymFile);

   Buffer[0]= MapDef.achModName[0];
   fread(Buffer + 1,1,MapDef.cbModName,SymFile);
   Buffer[MapDef.cbModName]=0;

#  ifdef DBGLRG
   printf("\nMapDef ppNextMap 0x%X bFlags 0x%X bReserved1 0x%X pSegEntry 0x%X\n"
	  " cConsts %d pConstDef 0x%X cSegs %d ppSegDef 0x%X\n"
	  " cbMaxSym %d cbModName %d achModName %s\n",
	  MapDef.ppNextMap, MapDef.bFlags, MapDef.bReserved1, MapDef.pSegEntry,
	  MapDef.cConsts, MapDef.pConstDef, MapDef.cSegs, MapDef.ppSegDef,
	  MapDef.cbMaxSym, MapDef.cbModName, Buffer);
#  endif // DBGLRG

   SegOffset=SEGDEFOFFSET(MapDef);

   for (SegNum=0;SegNum<MapDef.cSegs;SegNum++)
   {
#	ifdef DBGLRG
	printf("\nSegment #%d Offset 0x%X",SegNum+1,SegOffset);
#	endif // DBGLRG

	if (fseek(SymFile,SegOffset,SEEK_SET)) {
	   perror("Seek error ");
	   exit(1);
	}

	fread(&SegDef,sizeof(SEGDEF),1,SymFile);
	Buffer[0]= SegDef.achSegName[0];
	fread(Buffer + 1,1,SegDef.cbSegName,SymFile);
	Buffer[SegDef.cbSegName]=0;
#	ifdef DBGLRG
	printf(" ppNextSeg 0x%X cSymbols %d pSymDef 0x%X\n"
	       " wSegNum %d wInstance0 0x%X wInstance1 0x%X wInstance2 0x%X\n"
	       " bFlags 0x%X bReserved1 0x%X ppLineDef 0x%X\n"
	       " bIsSegLoaded %d bCurrInstance %d cbSegName %d %s\n\n",
	       SegDef.ppNextSeg, SegDef.cSymbols, SegDef.pSymDef, SegDef.wSegNum,
	       SegDef.wInstance0, SegDef.wInstance1, SegDef.wInstance2,
	       SegDef.bFlags, SegDef.bReserved1,
	       SegDef.ppLineDef, SegDef.bIsSegLoaded, SegDef.bCurrInstance,
	       SegDef.cbSegName, Buffer);
#	endif

	for (SymNum=0;SymNum<SegDef.cSymbols;SymNum++)
	{
	   SymPtrOffset=SYMDEFOFFSET(SegOffset,SegDef,SymNum);
#	   ifdef DBGLRG
	   printf("Sym #%d SymPtrOffset 0x%X",	SymNum+1,SymPtrOffset);
#	   endif
	   fseek(SymFile,SymPtrOffset,SEEK_SET);
	   fread(&SymOffset,sizeof(unsigned short int),1,SymFile);
#	   ifdef DBGLRG
	   printf(" SymOffset 0x%X SymOffset+SegOffset 0x%X\n",
		  SymOffset, SymOffset+SegOffset);
#	   endif
	   fseek(SymFile,SymOffset+SegOffset,SEEK_SET);

	   if (SegDef.bFlags&0x01) {
	      fread(&SymDef32,sizeof(SYMDEF32),1,SymFile);
	      Buffer[0]= SymDef32.achSymName[0];
	      fread(&Buffer[1],1,SymDef32.cbSymName,SymFile);
	      Buffer[SymDef32.cbSymName]=0;
	      printf("32 Bit Symbol <%s> Address %x:%x\n",
		     Buffer, SegNum + 1, SymDef32.wSymVal);
	   } else {
	      fread(&SymDef16,sizeof(SYMDEF16),1,SymFile);
	      Buffer[0]=SymDef16.achSymName[0];
	      fread(&Buffer[1],1,SymDef16.cbSymName,SymFile);
	      Buffer[SymDef16.cbSymName]=0;
	      printf("16 Bit Symbol <%s> Address %x:%x\n",
		     Buffer, SegNum + 1, SymDef16.wSymVal);
	   } /* endif */

	}

	SegOffset=NEXTSEGDEFOFFSET(SegDef);
   } /* for SegNum */

   fclose(SymFile);
   return 0;

} // main

// The end
